#include <string.h>
#include <windows.h>

#pragma comment( lib, "Winmm.lib" )

static bool TimeCounter_EnableQueryPerformance;
static TIMECAPS TimeCaps;

void TimeCounter_Initialize( void )
{
	// \ptH[}XJE^gp
	TimeCounter_EnableQueryPerformance = true;
	// }`fBA^C}̐x̐\擾Aݒ
	timeGetDevCaps( &TimeCaps, sizeof( TIMECAPS ) );
	timeBeginPeriod( TimeCaps.wPeriodMin );
}

void TimeCounter_Release( void )
{
	// }`fBA^C}̐x߂
	timeEndPeriod( TimeCaps.wPeriodMin );
}

// ʕbPʂ̎Ԃ߂
LARGE_INTEGER TimeCounter_Get( void )
{
	LARGE_INTEGER count;
	if( true == TimeCounter_EnableQueryPerformance )
	{
		DWORD cpumask;
		BOOL result;
		LARGE_INTEGER frequency;
		// 1 ڂ CPU w
		cpumask = ( DWORD )SetThreadAffinityMask( GetCurrentThread(), 1 );
		// \ptH[}XJE^
		result = QueryPerformanceFrequency( &frequency );
		if( 0 != result )
		{
			result = QueryPerformanceCounter( &count );
		}
		// CPU wɖ߂
		SetThreadAffinityMask( GetCurrentThread(), cpumask );
		if( 0 != result )
		{
			// Pʂʕbɍ킹
			count.QuadPart = ( count.QuadPart * 1000000L ) / frequency.QuadPart;
			return count;
		}
		// \ptH[}XJE^gȂ̂Ń}`fBA^C}Ɉڍs
		count.QuadPart = 0L;
		TimeCounter_EnableQueryPerformance = false;
	}
	// }`fBA^C}gp
	count.QuadPart = ( LONGLONG )timeGetTime() * 1000L;
	return count;
}
